Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# UniqueIdAllocator Class Reference

Manage a set of ID values from min to max inclusive. More...

List of all members.

## Public Member Functions
| UniqueIdAllocator (unsigned int min, unsigned int max)
| Create a free id pool in the range [min:max].
| UniqueIdAllocator (unsigned int min)
| Create a free id pool in the range [min:max].
| UniqueIdAllocator ()
| Create a free id pool in the range [min:max].
unsigned int | allocate ()
| Returns an id between _min and _max (that were passed to the constructor).
float | fractionUsed ()
| return the decimal fraction of the pool that is used.
| free (unsigned int index)
| Free an allocated index (index must be between _min and _max that were passed to the constructor).
| initialReserveId (unsigned int id)
| This may be called to mark a particular id as having already been allocated (for instance, by a prior pass).
| output (ostream out)
| ...intended for debugging only.
| write (ostream out)
| ...intended for debugging only.

## Detailed Description

Manage a set of ID values from min to max inclusive.

The ID numbers that are freed will be allocated (reused) in the same order. I.e. the oldest ID numbers will be allocated.

This implementation will use 4 bytes per id number, plus a few bytes of management data. e.g. 10,000 ID numbers will use 40KB.

Also be advised that ID -1 and -2 are used internally by the allocator. If allocate returns IndexEnd (-1) then the allocator is out of free ID numbers.

There are other implementations that can better leverage runs of used or unused IDs or use bit arrays for the IDs. But, it takes extra work to track the age of freed IDs, which is required for what we wanted. If you would like to kick around other implementation ideas, please contact Schuyler.

## Constructor & Destructor Documentation

UniqueIdAllocator | ( | unsigned int | min,
|  | unsigned int | max
| ) |  |

Create a free id pool in the range [min:max].

UniqueIdAllocator | ( | unsigned int | min | ) |

Create a free id pool in the range [min:max].

UniqueIdAllocator | ( |  | ) |

Create a free id pool in the range [min:max].

## Member Function Documentation

unsigned int allocate | ( |  | ) |

Returns an id between _min and _max (that were passed to the constructor).

IndexEnd is returned if no ids are available.

float fractionUsed | ( |  | ) |

return the decimal fraction of the pool that is used.

The range is 0 to 1.0 (e.g. 75% would be 0.75).

free | ( | unsigned int | index | ) |

Free an allocated index (index must be between _min and _max that were passed to the constructor).

initialReserveId | ( | unsigned int | id | ) |

This may be called to mark a particular id as having already been allocated (for instance, by a prior pass).

The specified id is removed from the available pool.

Because of the limitations of this algorithm, this is most efficient when it is called before the first call to allocate(), and when all the calls to initial_reserve_id() are made in descending order by id. However, this is a performance warning only; if performance is not an issue, any id may be reserved at any time.

output | ( | ostream | out | ) |

...intended for debugging only.

write | ( | ostream | out | ) |

...intended for debugging only.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties